--
-- BackHoe Working Script
--
-- by Zippo
-- 


BackHoe = {}

function BackHoe.prerequisitesPresent(specializations)
	Vehicle.registerJointType("frontloader");
    return SpecializationUtil.hasSpecialization(Steerable, specializations);
end;

function BackHoe:load(xmlFile)
	
	local translationPartNode = Utils.indexToObject(self.rootNode, getXMLString(xmlFile, "vehicle.translationPart#index"));
    if translationPartNode ~= nil then
        self.translationPart = {};
        self.translationPart.node = translationPartNode;
        local x, y, z = Utils.getVectorFromString(getXMLString(xmlFile, "vehicle.translationPart#minTrans"));
        self.translationPart.minTrans = {};
        self.translationPart.minTrans[1] = Utils.getNoNil(x, 0);
        self.translationPart.minTrans[2] = Utils.getNoNil(y, 0);
        self.translationPart.minTrans[3] = Utils.getNoNil(z, 0);

        x, y, z = Utils.getVectorFromString(getXMLString(xmlFile, "vehicle.translationPart#maxTrans"));
        self.translationPart.maxTrans = {};
        self.translationPart.maxTrans[1] = Utils.getNoNil(x, 0);
        self.translationPart.maxTrans[2] = Utils.getNoNil(y, 0);
        self.translationPart.maxTrans[3] = Utils.getNoNil(z, 0);

        self.translationPart.transTime = Utils.getNoNil(getXMLString(xmlFile, "vehicle.translationPart#transTime"), 2)*1000;
        self.translationPart.touchTransLimit = Utils.getNoNil(getXMLString(xmlFile, "vehicle.translationPart#touchTransLimit"), 10);
    end;
       
        local translationHydNode = Utils.indexToObject(self.rootNode, getXMLString(xmlFile, "vehicle.translationHyd#index"));
        if translationHydNode ~= nil then
        self.translationHyd = {};
        self.translationHyd.node = translationHydNode;
        local x, y, z = Utils.getVectorFromString(getXMLString(xmlFile, "vehicle.translationHyd#minTrans"));
        self.translationHyd.minTrans = {};
        self.translationHyd.minTrans[1] = Utils.getNoNil(x, 0);
        self.translationHyd.minTrans[2] = Utils.getNoNil(y, 0);
        self.translationHyd.minTrans[3] = Utils.getNoNil(z, 0);

        x, y, z = Utils.getVectorFromString(getXMLString(xmlFile, "vehicle.translationHyd#maxTrans"));
        self.translationHyd.maxTrans = {};
        self.translationHyd.maxTrans[1] = Utils.getNoNil(x, 0);
        self.translationHyd.maxTrans[2] = Utils.getNoNil(y, 0);
        self.translationHyd.maxTrans[3] = Utils.getNoNil(z, 0);

        self.translationHyd.transTime = Utils.getNoNil(getXMLString(xmlFile, "vehicle.translationHyd#transTime"), 2)*1000;
        self.translationHyd.touchTransLimit = Utils.getNoNil(getXMLString(xmlFile, "vehicle.translationHyd#touchTransLimit"), 10);
    end;

       local translationHyd2Node = Utils.indexToObject(self.rootNode, getXMLString(xmlFile, "vehicle.translationHyd2#index"));
        if translationHyd2Node ~= nil then
        self.translationHyd2 = {};
        self.translationHyd2.node = translationHyd2Node;
        local x, y, z = Utils.getVectorFromString(getXMLString(xmlFile, "vehicle.translationHyd2#minTrans"));
        self.translationHyd2.minTrans = {};
        self.translationHyd2.minTrans[1] = Utils.getNoNil(x, 0);
        self.translationHyd2.minTrans[2] = Utils.getNoNil(y, 0);
        self.translationHyd2.minTrans[3] = Utils.getNoNil(z, 0);

        x, y, z = Utils.getVectorFromString(getXMLString(xmlFile, "vehicle.translationHyd2#maxTrans"));
        self.translationHyd2.maxTrans = {};
        self.translationHyd2.maxTrans[1] = Utils.getNoNil(x, 0);
        self.translationHyd2.maxTrans[2] = Utils.getNoNil(y, 0);
        self.translationHyd2.maxTrans[3] = Utils.getNoNil(z, 0);

        self.translationHyd2.transTime = Utils.getNoNil(getXMLString(xmlFile, "vehicle.translationHyd2#transTime"), 2)*1000;
        self.translationHyd2.touchTransLimit = Utils.getNoNil(getXMLString(xmlFile, "vehicle.translationHyd2#touchTransLimit"), 10);
    end;

       local translationArmSecNode = Utils.indexToObject(self.rootNode, getXMLString(xmlFile, "vehicle.translationArmSec#index"));
        if translationArmSecNode ~= nil then
        self.translationArmSec = {};
        self.translationArmSec.node = translationArmSecNode;
        local x, y, z = Utils.getVectorFromString(getXMLString(xmlFile, "vehicle.translationArmSec#minTrans"));
        self.translationArmSec.minTrans = {};
        self.translationArmSec.minTrans[1] = Utils.getNoNil(x, 0);
        self.translationArmSec.minTrans[2] = Utils.getNoNil(y, 0);
        self.translationArmSec.minTrans[3] = Utils.getNoNil(z, 0);

        x, y, z = Utils.getVectorFromString(getXMLString(xmlFile, "vehicle.translationArmSec#maxTrans"));
        self.translationArmSec.maxTrans = {};
        self.translationArmSec.maxTrans[1] = Utils.getNoNil(x, 0);
        self.translationArmSec.maxTrans[2] = Utils.getNoNil(y, 0);
        self.translationArmSec.maxTrans[3] = Utils.getNoNil(z, 0);

        self.translationArmSec.transTime = Utils.getNoNil(getXMLString(xmlFile, "vehicle.translationArmSec#transTime"), 2)*1000;
        self.translationArmSec.touchTransLimit = Utils.getNoNil(getXMLString(xmlFile, "vehicle.translationArmSec#touchTransLimit"), 10);
    end;

	local translationFrontHydNode = Utils.indexToObject(self.rootNode, getXMLString(xmlFile, "vehicle.translationFrontHyd#index"));
        if translationFrontHydNode ~= nil then
        self.translationFrontHyd = {};
        self.translationFrontHyd.node = translationFrontHydNode;
        local x, y, z = Utils.getVectorFromString(getXMLString(xmlFile, "vehicle.translationFrontHyd#minTrans"));
        self.translationFrontHyd.minTrans = {};
        self.translationFrontHyd.minTrans[1] = Utils.getNoNil(x, 0);
        self.translationFrontHyd.minTrans[2] = Utils.getNoNil(y, 0);
        self.translationFrontHyd.minTrans[3] = Utils.getNoNil(z, 0);

        x, y, z = Utils.getVectorFromString(getXMLString(xmlFile, "vehicle.translationFrontHyd#maxTrans"));
        self.translationFrontHyd.maxTrans = {};
        self.translationFrontHyd.maxTrans[1] = Utils.getNoNil(x, 0);
        self.translationFrontHyd.maxTrans[2] = Utils.getNoNil(y, 0);
        self.translationFrontHyd.maxTrans[3] = Utils.getNoNil(z, 0);

        self.translationFrontHyd.transTime = Utils.getNoNil(getXMLString(xmlFile, "vehicle.translationFrontHyd#transTime"), 2)*1000;
        self.translationFrontHyd.touchTransLimit = Utils.getNoNil(getXMLString(xmlFile, "vehicle.translationFrontHyd#touchTransLimit"), 10);
    end;
    
	local rotationNode1 = Utils.indexToObject(self.rootNode, getXMLString(xmlFile, "vehicle.rotation1#index"));
    if rotationNode1 ~= nil then
        self.rotation1 = {};
        self.rotation1.node = rotationNode1;
        local x, y, z = Utils.getVectorFromString(getXMLString(xmlFile, "vehicle.rotation1#minRot"));
        self.rotation1.minRot = {};
        self.rotation1.minRot[1] = Utils.degToRad(Utils.getNoNil(x, 0));
        self.rotation1.minRot[2] = Utils.degToRad(Utils.getNoNil(y, 0));
        self.rotation1.minRot[3] = Utils.degToRad(Utils.getNoNil(z, 0));

        x, y, z = Utils.getVectorFromString(getXMLString(xmlFile, "vehicle.rotation1#maxRot"));
        self.rotation1.maxRot = {};
        self.rotation1.maxRot[1] = Utils.degToRad(Utils.getNoNil(x, 0));
        self.rotation1.maxRot[2] = Utils.degToRad(Utils.getNoNil(y, 0));
        self.rotation1.maxRot[3] = Utils.degToRad(Utils.getNoNil(z, 0));

        self.rotation1.rotTime = Utils.getNoNil(getXMLString(xmlFile, "vehicle.rotation1#rotTime"), 2)*1000;
        self.rotation1.touchRotLimit = Utils.degToRad(Utils.getNoNil(getXMLString(xmlFile, "vehicle.rotation1#touchRotLimit"), 10));
    end;
	
	local rotationNode2 = Utils.indexToObject(self.rootNode, getXMLString(xmlFile, "vehicle.rotation2#index"));
    if rotationNode2 ~= nil then
        self.rotation2 = {};
        self.rotation2.node = rotationNode2;
        local x, y, z = Utils.getVectorFromString(getXMLString(xmlFile, "vehicle.rotation2#minRot"));
        self.rotation2.minRot = {};
        self.rotation2.minRot[1] = Utils.degToRad(Utils.getNoNil(x, 0));
        self.rotation2.minRot[2] = Utils.degToRad(Utils.getNoNil(y, 0));
        self.rotation2.minRot[3] = Utils.degToRad(Utils.getNoNil(z, 0));

        x, y, z = Utils.getVectorFromString(getXMLString(xmlFile, "vehicle.rotation2#maxRot"));
        self.rotation2.maxRot = {};
        self.rotation2.maxRot[1] = Utils.degToRad(Utils.getNoNil(x, 0));
        self.rotation2.maxRot[2] = Utils.degToRad(Utils.getNoNil(y, 0));
        self.rotation2.maxRot[3] = Utils.degToRad(Utils.getNoNil(z, 0));

        self.rotation2.rotTime = Utils.getNoNil(getXMLString(xmlFile, "vehicle.rotation2#rotTime"), 2)*1000;
        self.rotation2.touchRotLimit = Utils.degToRad(Utils.getNoNil(getXMLString(xmlFile, "vehicle.rotation2#touchRotLimit"), 10));
    end;
    local rotationNode3 = Utils.indexToObject(self.rootNode, getXMLString(xmlFile, "vehicle.rotation3#index"));
    if rotationNode3 ~= nil then
        self.rotation3 = {};
        self.rotation3.node = rotationNode3;
        local x, y, z = Utils.getVectorFromString(getXMLString(xmlFile, "vehicle.rotation3#minRot"));
        self.rotation3.minRot = {};
        self.rotation3.minRot[1] = Utils.degToRad(Utils.getNoNil(x, 0));
        self.rotation3.minRot[2] = Utils.degToRad(Utils.getNoNil(y, 0));
        self.rotation3.minRot[3] = Utils.degToRad(Utils.getNoNil(z, 0));

        x, y, z = Utils.getVectorFromString(getXMLString(xmlFile, "vehicle.rotation3#maxRot"));
        self.rotation3.maxRot = {};
        self.rotation3.maxRot[1] = Utils.degToRad(Utils.getNoNil(x, 0));
        self.rotation3.maxRot[2] = Utils.degToRad(Utils.getNoNil(y, 0));
        self.rotation3.maxRot[3] = Utils.degToRad(Utils.getNoNil(z, 0));

        self.rotation3.rotTime = Utils.getNoNil(getXMLString(xmlFile, "vehicle.rotation3#rotTime"), 2)*1000;
        self.rotation3.touchRotLimit = Utils.degToRad(Utils.getNoNil(getXMLString(xmlFile, "vehicle.rotation3#touchRotLimit"), 10));
    end;
    
      local rotationNode4 = Utils.indexToObject(self.rootNode, getXMLString(xmlFile, "vehicle.rotation4#index"));
    if rotationNode4 ~= nil then
        self.rotation4 = {};
        self.rotation4.node = rotationNode4;
        local x, y, z = Utils.getVectorFromString(getXMLString(xmlFile, "vehicle.rotation4#minRot"));
        self.rotation4.minRot = {};
        self.rotation4.minRot[1] = Utils.degToRad(Utils.getNoNil(x, 0));
        self.rotation4.minRot[2] = Utils.degToRad(Utils.getNoNil(y, 0));
        self.rotation4.minRot[3] = Utils.degToRad(Utils.getNoNil(z, 0));

        x, y, z = Utils.getVectorFromString(getXMLString(xmlFile, "vehicle.rotation4#maxRot"));
        self.rotation4.maxRot = {};
        self.rotation4.maxRot[1] = Utils.degToRad(Utils.getNoNil(x, 0));
        self.rotation4.maxRot[2] = Utils.degToRad(Utils.getNoNil(y, 0));
        self.rotation4.maxRot[3] = Utils.degToRad(Utils.getNoNil(z, 0));

        self.rotation4.rotTime = Utils.getNoNil(getXMLString(xmlFile, "vehicle.rotation4#rotTime"), 2)*1000;
        self.rotation4.touchRotLimit = Utils.degToRad(Utils.getNoNil(getXMLString(xmlFile, "vehicle.rotation4#touchRotLimit"), 10));
    end;
 
         local rotationNode5 = Utils.indexToObject(self.rootNode, getXMLString(xmlFile, "vehicle.rotation5#index"));
    if rotationNode5 ~= nil then
        self.rotation5 = {};
        self.rotation5.node = rotationNode5;
        local x, y, z = Utils.getVectorFromString(getXMLString(xmlFile, "vehicle.rotation5#minRot"));
        self.rotation5.minRot = {};
        self.rotation5.minRot[1] = Utils.degToRad(Utils.getNoNil(x, 0));
        self.rotation5.minRot[2] = Utils.degToRad(Utils.getNoNil(y, 0));
        self.rotation5.minRot[3] = Utils.degToRad(Utils.getNoNil(z, 0));

        x, y, z = Utils.getVectorFromString(getXMLString(xmlFile, "vehicle.rotation5#maxRot"));
        self.rotation5.maxRot = {};
        self.rotation5.maxRot[1] = Utils.degToRad(Utils.getNoNil(x, 0));
        self.rotation5.maxRot[2] = Utils.degToRad(Utils.getNoNil(y, 0));
        self.rotation5.maxRot[3] = Utils.degToRad(Utils.getNoNil(z, 0));

        self.rotation5.rotTime = Utils.getNoNil(getXMLString(xmlFile, "vehicle.rotation5#rotTime"), 2)*1000;
        self.rotation5.touchRotLimit = Utils.degToRad(Utils.getNoNil(getXMLString(xmlFile, "vehicle.rotation5#touchRotLimit"), 10));
    end;
 
	local rotationNode6 = Utils.indexToObject(self.rootNode, getXMLString(xmlFile, "vehicle.rotation6#index"));
    if rotationNode6 ~= nil then
        self.rotation6 = {};
        self.rotation6.node = rotationNode6;
        local x, y, z = Utils.getVectorFromString(getXMLString(xmlFile, "vehicle.rotation6#minRot"));
        self.rotation6.minRot = {};
        self.rotation6.minRot[1] = Utils.degToRad(Utils.getNoNil(x, 0));
        self.rotation6.minRot[2] = Utils.degToRad(Utils.getNoNil(y, 0));
        self.rotation6.minRot[3] = Utils.degToRad(Utils.getNoNil(z, 0));

        x, y, z = Utils.getVectorFromString(getXMLString(xmlFile, "vehicle.rotation6#maxRot"));
        self.rotation6.maxRot = {};
        self.rotation6.maxRot[1] = Utils.degToRad(Utils.getNoNil(x, 0));
        self.rotation6.maxRot[2] = Utils.degToRad(Utils.getNoNil(y, 0));
        self.rotation6.maxRot[3] = Utils.degToRad(Utils.getNoNil(z, 0));

        self.rotation6.rotTime = Utils.getNoNil(getXMLString(xmlFile, "vehicle.rotation6#rotTime"), 2)*1000;
        self.rotation6.touchRotLimit = Utils.degToRad(Utils.getNoNil(getXMLString(xmlFile, "vehicle.rotation6#touchRotLimit"), 10));
    end;

local rotationNode7 = Utils.indexToObject(self.rootNode, getXMLString(xmlFile, "vehicle.rotation7#index"));
    if rotationNode7 ~= nil then
        self.rotation7 = {};
        self.rotation7.node = rotationNode7;
        local x, y, z = Utils.getVectorFromString(getXMLString(xmlFile, "vehicle.rotation7#minRot"));
        self.rotation7.minRot = {};
        self.rotation7.minRot[1] = Utils.degToRad(Utils.getNoNil(x, 0));
        self.rotation7.minRot[2] = Utils.degToRad(Utils.getNoNil(y, 0));
        self.rotation7.minRot[3] = Utils.degToRad(Utils.getNoNil(z, 0));

        x, y, z = Utils.getVectorFromString(getXMLString(xmlFile, "vehicle.rotation7#maxRot"));
        self.rotation7.maxRot = {};
        self.rotation7.maxRot[1] = Utils.degToRad(Utils.getNoNil(x, 0));
        self.rotation7.maxRot[2] = Utils.degToRad(Utils.getNoNil(y, 0));
        self.rotation7.maxRot[3] = Utils.degToRad(Utils.getNoNil(z, 0));

        self.rotation7.rotTime = Utils.getNoNil(getXMLString(xmlFile, "vehicle.rotation7#rotTime"), 2)*1000;
        self.rotation7.touchRotLimit = Utils.degToRad(Utils.getNoNil(getXMLString(xmlFile, "vehicle.rotation7#touchRotLimit"), 10));
    end;

local rotationNode8 = Utils.indexToObject(self.rootNode, getXMLString(xmlFile, "vehicle.rotation8#index"));
    if rotationNode8 ~= nil then
        self.rotation8 = {};
        self.rotation8.node = rotationNode8;
        local x, y, z = Utils.getVectorFromString(getXMLString(xmlFile, "vehicle.rotation8#minRot"));
        self.rotation8.minRot = {};
        self.rotation8.minRot[1] = Utils.degToRad(Utils.getNoNil(x, 0));
        self.rotation8.minRot[2] = Utils.degToRad(Utils.getNoNil(y, 0));
        self.rotation8.minRot[3] = Utils.degToRad(Utils.getNoNil(z, 0));

        x, y, z = Utils.getVectorFromString(getXMLString(xmlFile, "vehicle.rotation8#maxRot"));
        self.rotation8.maxRot = {};
        self.rotation8.maxRot[1] = Utils.degToRad(Utils.getNoNil(x, 0));
        self.rotation8.maxRot[2] = Utils.degToRad(Utils.getNoNil(y, 0));
        self.rotation8.maxRot[3] = Utils.degToRad(Utils.getNoNil(z, 0));

        self.rotation8.rotTime = Utils.getNoNil(getXMLString(xmlFile, "vehicle.rotation8#rotTime"), 2)*1000;
        self.rotation8.touchRotLimit = Utils.degToRad(Utils.getNoNil(getXMLString(xmlFile, "vehicle.rotation8#touchRotLimit"), 10));
    end;

local rotationNode9 = Utils.indexToObject(self.rootNode, getXMLString(xmlFile, "vehicle.rotation9#index"));
    if rotationNode9 ~= nil then
        self.rotation9 = {};
        self.rotation9.node = rotationNode9;
        local x, y, z = Utils.getVectorFromString(getXMLString(xmlFile, "vehicle.rotation9#minRot"));
        self.rotation9.minRot = {};
        self.rotation9.minRot[1] = Utils.degToRad(Utils.getNoNil(x, 0));
        self.rotation9.minRot[2] = Utils.degToRad(Utils.getNoNil(y, 0));
        self.rotation9.minRot[3] = Utils.degToRad(Utils.getNoNil(z, 0));

        x, y, z = Utils.getVectorFromString(getXMLString(xmlFile, "vehicle.rotation9#maxRot"));
        self.rotation9.maxRot = {};
        self.rotation9.maxRot[1] = Utils.degToRad(Utils.getNoNil(x, 0));
        self.rotation9.maxRot[2] = Utils.degToRad(Utils.getNoNil(y, 0));
        self.rotation9.maxRot[3] = Utils.degToRad(Utils.getNoNil(z, 0));

        self.rotation9.rotTime = Utils.getNoNil(getXMLString(xmlFile, "vehicle.rotation9#rotTime"), 2)*1000;
        self.rotation9.touchRotLimit = Utils.degToRad(Utils.getNoNil(getXMLString(xmlFile, "vehicle.rotation9#touchRotLimit"), 10));
    end;

hydra1SoundFile = Utils.getFilename("hydra1.wav", self.baseDirectory);
    self.hydra1SoundId = createSample("HYD1_hydra1");
    loadSample(self.hydra1SoundId, hydra1SoundFile, false);
    self.hydra1Playing = false;

hydra2SoundFile = Utils.getFilename("hydra2.wav", self.baseDirectory);
    self.hydra2SoundId = createSample("HYD2_hydra2");
    loadSample(self.hydra2SoundId, hydra2SoundFile, false);
    self.hydra2Playing = false;
    
end;
      
function BackHoe:delete()
end;

function BackHoe:mouseEvent(posX, posY, isDown, isUp, button)
end;
	  
function BackHoe:keyEvent(unicode, sym, modifier, isDown)

    if sym == Input.KEY_m then
		self.translationMax = isDown;
	end;
	if sym == Input.KEY_n then
		self.translationMin = isDown;
	end;
	if sym == Input.KEY_x then
		self.rotation1Max = isDown;
	end;
	if sym == Input.KEY_z then
		self.rotation1Min = isDown;
	end;
	if sym == Input.KEY_KP_4 then
		self.rotation2Max = isDown;
	end;
	if sym == Input.KEY_KP_7 then
		self.rotation2Min = isDown;
	end;
	if sym == Input.KEY_KP_8 then
		self.rotation3Max = isDown;
		self.translationHydMax = isDown;
	end;
	if sym == Input.KEY_KP_5 then
		self.rotation3Min = isDown;
		self.translationHydMin = isDown;
	end;
	if sym == Input.KEY_KP_9 then
		self.translationArmSecMax = isDown;
	end;
	if sym == Input.KEY_KP_6 then
		self.translationArmSecMin = isDown;
	end;
	if sym == Input.KEY_KP_0 then
		self.rotation5Max = isDown;
		self.translationHyd2Max = isDown;
	end;
	if sym == Input.KEY_KP_2 then
		self.rotation5Min = isDown;
		self.translationHyd2Min = isDown;
	end;
	if sym == Input.KEY_pageup then
		self.rotation6Max = isDown;
		self.rotation7Max = isDown;
		self.translationFrontHydMax = isDown;
	end;
	if sym == Input.KEY_pagedown then
		self.rotation6Min = isDown;
		self.rotation7Min = isDown;
		self.translationFrontHydMin = isDown;
	end;
	if sym == Input.KEY_KP_divide then
		self.rotation8Max = isDown;
	end;
	if sym == Input.KEY_KP_multiply then
		self.rotation8Min = isDown;
	end;
	if sym == Input.KEY_home then
		self.rotation9Max = isDown;
	end;
	if sym == Input.KEY_end then
		self.rotation9Min = isDown;
	end;

end;

function BackHoe:update(dt)
	
	local doTranslate = self.translationMax or self.translationMin 
	if self.translationPart ~= nil and doTranslate then 
		local x, y, z = getTranslation(self.translationPart.node); 
		local trans = {x,y,z}; 
		local newTrans = Utils.getMovedLimitedValues(trans, self.translationPart.maxTrans, self.translationPart.minTrans, 3, self.translationPart.transTime, dt, not self.translationMax); 
		setTranslation(self.translationPart.node, unpack(newTrans)); 
	end;

	local doTranslate = self.translationHydMax or self.translationHydMin 
	if self.translationHyd ~= nil and doTranslate then 
		local x, y, z = getTranslation(self.translationHyd.node); 
		local trans = {x,y,z}; 
		local newTrans = Utils.getMovedLimitedValues(trans, self.translationHyd.maxTrans, self.translationHyd.minTrans, 3, self.translationHyd.transTime, dt, not self.translationHydMax); 
		setTranslation(self.translationHyd.node, unpack(newTrans)); 
	end;

	local doTranslate = self.translationHyd2Max or self.translationHyd2Min 
	if self.translationHyd2 ~= nil and doTranslate then 
		local x, y, z = getTranslation(self.translationHyd2.node); 
		local trans = {x,y,z}; 
		local newTrans = Utils.getMovedLimitedValues(trans, self.translationHyd2.maxTrans, self.translationHyd2.minTrans, 3, self.translationHyd2.transTime, dt, not self.translationHyd2Max); 
		setTranslation(self.translationHyd2.node, unpack(newTrans)); 
	end;

	local doTranslate = self.translationArmSecMax or self.translationArmSecMin 
	if self.translationArmSec ~= nil and doTranslate then 
		local x, y, z = getTranslation(self.translationArmSec.node); 
		local trans = {x,y,z}; 
		local newTrans = Utils.getMovedLimitedValues(trans, self.translationArmSec.maxTrans, self.translationArmSec.minTrans, 3, self.translationArmSec.transTime, dt, not self.translationArmSecMax); 
		setTranslation(self.translationArmSec.node, unpack(newTrans)); 
	end;

	local doTranslate = self.translationFrontHydMax or self.translationFrontHydMin 
	if self.translationFrontHyd ~= nil and doTranslate then 
		local x, y, z = getTranslation(self.translationFrontHyd.node); 
		local trans = {x,y,z}; 
		local newTrans = Utils.getMovedLimitedValues(trans, self.translationFrontHyd.maxTrans, self.translationFrontHyd.minTrans, 3, self.translationFrontHyd.transTime, dt, not self.translationFrontHydMax); 
		setTranslation(self.translationFrontHyd.node, unpack(newTrans)); 
	end;
	
	local doRotate = self.rotation1Max or self.rotation1Min 
	if self.rotation1 ~= nil and doRotate then
        local x, y, z = getRotation(self.rotation1.node);
        local rot = {x,y,z};
        local newRot = Utils.getMovedLimitedValues(rot, self.rotation1.maxRot, self.rotation1.minRot, 3, self.rotation1.rotTime, dt, not self.rotation1Max);
        setRotation(self.rotation1.node, unpack(newRot));
        end;
	
	local doRotate = self.rotation2Max or self.rotation2Min 
	if self.rotation2 ~= nil and doRotate then
        local x, y, z = getRotation(self.rotation2.node);
        local rot = {x,y,z};
        local newRot = Utils.getMovedLimitedValues(rot, self.rotation2.maxRot, self.rotation2.minRot, 3, self.rotation2.rotTime, dt, not self.rotation2Max);
        setRotation(self.rotation2.node, unpack(newRot));
        end;
    
    local doRotate = self.rotation3Max or self.rotation3Min 
	if self.rotation3 ~= nil and doRotate then
        local x, y, z = getRotation(self.rotation3.node);
        local rot = {x,y,z};
        local newRot = Utils.getMovedLimitedValues(rot, self.rotation3.maxRot, self.rotation3.minRot, 3, self.rotation3.rotTime, dt, not self.rotation3Max);
        setRotation(self.rotation3.node, unpack(newRot));
    end;
    
       local doRotate = self.rotation4Max or self.rotation4Min 
	if self.rotation4 ~= nil and doRotate then
        local x, y, z = getRotation(self.rotation4.node);
        local rot = {x,y,z};
        local newRot = Utils.getMovedLimitedValues(rot, self.rotation4.maxRot, self.rotation4.minRot, 3, self.rotation4.rotTime, dt, not self.rotation4Max);
        setRotation(self.rotation4.node, unpack(newRot));
        end;
	
	   local doRotate = self.rotation5Max or self.rotation5Min 
	if self.rotation5 ~= nil and doRotate then
        local x, y, z = getRotation(self.rotation5.node);
        local rot = {x,y,z};
        local newRot = Utils.getMovedLimitedValues(rot, self.rotation5.maxRot, self.rotation5.minRot, 3, self.rotation5.rotTime, dt, not self.rotation5Max);
        setRotation(self.rotation5.node, unpack(newRot));
        end;
	
	local doRotate = self.rotation6Max or self.rotation6Min 
	if self.rotation6 ~= nil and doRotate then
        local x, y, z = getRotation(self.rotation6.node);
        local rot = {x,y,z};
        local newRot = Utils.getMovedLimitedValues(rot, self.rotation6.maxRot, self.rotation6.minRot, 3, self.rotation6.rotTime, dt, not self.rotation6Max);
        setRotation(self.rotation6.node, unpack(newRot));
        if not self.hydra1Playing then
            playSample(self.hydra1SoundId, 0, 1, 0);
            self.hydra1Playing = true;
        end;
    else
        if self.hydra1Playing then
            stopSample(self.hydra1SoundId);
            self.hydra1Playing = false;
        end;
    end;

	local doRotate = self.rotation7Max or self.rotation7Min 
	if self.rotation7 ~= nil and doRotate then
        local x, y, z = getRotation(self.rotation7.node);
        local rot = {x,y,z};
        local newRot = Utils.getMovedLimitedValues(rot, self.rotation7.maxRot, self.rotation7.minRot, 3, self.rotation7.rotTime, dt, not self.rotation7Max);
        setRotation(self.rotation7.node, unpack(newRot));
    end;

	local doRotate = self.rotation8Max or self.rotation8Min 
	if self.rotation8 ~= nil and doRotate then
        local x, y, z = getRotation(self.rotation8.node);
        local rot = {x,y,z};
        local newRot = Utils.getMovedLimitedValues(rot, self.rotation8.maxRot, self.rotation8.minRot, 3, self.rotation8.rotTime, dt, not self.rotation8Max);
        setRotation(self.rotation8.node, unpack(newRot));
    end;

	local doRotate = self.rotation9Max or self.rotation9Min 
	if self.rotation9 ~= nil and doRotate then
        local x, y, z = getRotation(self.rotation9.node);
        local rot = {x,y,z};
        local newRot = Utils.getMovedLimitedValues(rot, self.rotation9.maxRot, self.rotation9.minRot, 3, self.rotation9.rotTime, dt, not self.rotation9Max);
        setRotation(self.rotation9.node, unpack(newRot));
        if not self.hydra2Playing then
            playSample(self.hydra2SoundId, 0, 1, 0);
            self.hydra2Playing = true;
        end;
    else
        if self.hydra2Playing then
            stopSample(self.hydra2SoundId);
            self.hydra2Playing = false;
        end;
    end;

end;

function BackHoe:draw()
end;

function BackHoe:validateAttacherJoint(implement, jointDesc, dt)
    return true;
end;
